﻿using System;
using ThinkGeo.MapSuite.Core;
using System.Web.UI;
using MicrosoftMapLayerExtension.net.virtualearth.common.staging;

namespace CSSamples.Samples.NavigateTheMap
{
    public partial class ExtentChangedEvent : System.Web.UI.Page, ICallbackEventHandler
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.StaticOverlay.Layers.Add("WorldLayer", worldLayer);

                Map1.OnClientExtentChanged = "Map1ExtentChanged";
            }
        }

        protected void Map1_ExtentChanged(object sender, ThinkGeo.MapSuite.WebEdition.ExtentChangedEventArgs e)
        {
            dataContainer.Visible = true;

            lbCurrentScale.Text = e.CurrentScale.ToString("n4");
            string currentExtent = String.Format("({0}, {1}, {2}, {3})",
                e.CurrentExtent.UpperLeftPoint.X.ToString("n4"), e.CurrentExtent.UpperLeftPoint.Y.ToString("n4"),
                e.CurrentExtent.LowerRightPoint.X.ToString("n4"), e.CurrentExtent.LowerRightPoint.Y.ToString("n4"));
            divExtent.InnerHtml = currentExtent;
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
        }

        #region ICallbackEventHandler Members

        private string callbackString;

        public string GetCallbackResult()
        {
            return callbackString;
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            ShapeFileFeatureLayer layer = (ShapeFileFeatureLayer)Map1.StaticOverlay.Layers["WorldLayer"];
            lock (layer)
            {
                layer.Open();
                callbackString = layer.FeatureSource.GetFeaturesInsideBoundingBox(BaseShape.CreateShapeFromWellKnownData(eventArgument).GetBoundingBox(), ReturningColumnsType.NoColumns).Count.ToString();
                layer.Close();
            }
        }
        #endregion
    }
}
